<template>
    <div>
        <div class="breadcrumbs">
            <router-link to="/main">{{$t('message.main')}}</router-link>
            <div class="circle"></div>
            <div>{{$t('message.departure_in_ukraine')}}</div>
        </div>

        <!--        <div class="popup_success_window">-->
        <!--            <menu-component></menu-component>-->
        <!--            <div class="message">-->
        <!--                <div class="title_message">{{$t('message.under_construction')}}</div>-->
        <!--                <div class="package_number">&nbsp;</div>-->
        <!--                <div class="controls">-->
        <!--                    <div class="actions">-->
        <!--                        <router-link to="/package/create" class="button">{{$t('message.create_cargo')}}</router-link>-->
        <!--                        <router-link to="/" class="button">{{$t('message.to_main')}}</router-link>-->
        <!--                    </div>-->
        <!--                </div>-->
        <!--            </div>-->
        <!--        </div>-->

        <!-- <div class="test" v-if='loaded'> -->
        <!-- 111-->
        <!-- </div>-->

        <div class="orders">
            <div :class="{bg_shadow: true, opened: filterPopups.filter == true || filterPopups.sorting == true || filterPopups.search == true}"></div>

            <div class="filter">
                <div class="btn" :class="{active: filterPopups.filter, filtered: filtersSelected}"
                     @click="toggleFilterPopup">
                    {{$t('message.filter')}}
                    <div class="icon">
                        <plus-svg></plus-svg>
                    </div>
                </div>
                <div class="btn" :class="{active: filterPopups.sorting, filtered: sortingSelected}"
                     @click="showSortingFilter">
                    {{$t('message.sorting')}}
                    <div class="icon">
                        <plus-svg></plus-svg>
                    </div>
                </div>
                <div class="search" :class="{active: filterPopups.search, filtered: searchFilled}"
                     @click="toggleSearchPopup">
                    <search-svg></search-svg>
                </div>
            </div>

            <!--   Фильтрация   -->
            <orders-filter
                :isOpened="filterPopups.filter"
                :isIncomming="filters.is_incoming"
                :cities="cities"
                :departments="departments"
                @close="closePopup('filter')"
                @filter="onFilterApplied"
                ref="ordersFilter"
            ></orders-filter>

            <!--  Сортировка     -->
            <orders-sorting
                :isOpened="filterPopups.sorting"
                @close="closePopup('sorting')"
                @resort="onResort"
            ></orders-sorting>

            <!--  Попап поиска          -->
            <orders-search
                :isOpened="filterPopups.search"
                @close="closePopup('search')"
                @search="onSearch"
            ></orders-search>

            <v-tabs v-model="tab">
                <v-tabs-slider></v-tabs-slider>
                <div class="tabs_wrapper">
                    <v-tab href="#tab-1" :ripple="false" @click="changeOrdersTab(0)">
                        {{ $t('message.out_package')}}
                        <span v-if="Object.keys(ordersQty).length">({{ ordersQty.outcoming }})</span>
                    </v-tab>
                    <v-tab href="#tab-2" :ripple="false" @click="changeOrdersTab(1)">
                        {{ $t('message.in_package') }}
                        <span v-if="Object.keys(ordersQty).length">({{ ordersQty.incoming }})</span>
                    </v-tab>

                    <div class="payback active" @click="toggleArchive();">
                        <div :class="{switcher: true, active: (filters.is_archive === 0)}"></div>
                        <div class="payback_container">
                            <div class="payback_container_label">
                                {{$t('message.only_active_orders')}}
                            </div>
                            <input id='get_payback' type="checkbox" style="display: none">
                        </div>
                    </div>
                </div>
                <v-tab-item :key="1" :value="'tab-1'">
                    <div v-if="!isMobile()">
                        <table class="temp-package">
                            <thead>
                                <tr>
                                    <td>{{$t('message.en_num')}}</td>
                                    <td>{{$t('message.full_name_receiver')}}</td>
                                    <td>{{$t('message.phone_receiver')}}</td>
                                    <td>{{$t('message.department_number_and_address')}}</td>
                                    <td>{{$t('message.weight')}}</td>
                                    <td>{{$t('message.description')}}</td>
                                    <td>{{$t('message.created_at')}}</td>
                                    <td>{{$t('message.to_bill')}}</td>
                                    <td>{{$t('message.status')}}</td>
                                </tr>
                            </thead>

                            <tbody>
                                <template v-if="Object.keys(orders).length > 0">
                                    <tr v-for="(order, index) in orders" :key="index" @click="goToDetails($event, order.ew_number)">
                                        <td>{{ order.ew_number }}</td>
                                        <td :title="order.receiver_company">
                                            <span v-if="order.delivery_type !== 'C2B'">
                                                {{ order.receiver_last_name }} {{order.receiver_first_name}} {{order.receiver_second_name}}
                                            </span>
                                            <span v-else>
                                                {{ order.receiver_company }}
                                            </span>
                                        </td>
                                        <td>
                                            <span v-if="order.delivery_type !== 'C2B'">
                                                <a :href="`tel:${order.receiver_phone}`" class="phone">{{ order.receiver_phone | formatPhone }}</a>
                                            </span>
                                            <span v-else>
                                                {{ $t('message.not_available') }}
                                            </span>
                                        </td>
                                        <td style="text-transform: capitalize">
                                            {{$t('message.department')}} №{{order.receiver_department_number}} ({{ order.sender_department_address_ua }})
                                        </td>
                                        <td>{{ order.weight | formatWeight }}</td>
                                        <td>{{ order.description }}</td>
                                        <td>{{ order.order_date | formatDate }}</td>
                                        <td>{{ order.cost_pay_sender | formatPrice }}</td>
                                        <td :title="order.order_date">
                                            <div class="actions">
                                                <div
                                                    class="status"
                                                    :class="{
                                                        'status--lightblue':(order.status_id == 1),
                                                        'status--blue':([3,4,5,16].includes(parseInt(order.status_id))),
                                                        'status--green':([6,8].includes(parseInt(order.status_id))),
                                                        'status--red':([2,9,14,15].includes(parseInt(order.status_id))),
                                                    }"
                                                >
                                                    {{statuses[order.status_id] ? statuses[order.status_id].name_ua : ''}}
                                                    <!--                                                {{statuses[order.status_id]}}-->
                                                    <!--                                                {{$t('message.txt_status')}}-->
                                                    <!--                                                {{ order.status.name }}-->
                                                </div>
                                                <div @click="toOrder(order)" class="btn">
                                                    {{$t('message.detail_info')}}
                                                    <div class="icon">
                                                        <plus-svg></plus-svg>
                                                    </div>
                                                </div>
                                            </div>
                                        </td>
                                    </tr>
                                </template>
                                <tr v-if="!isLoading && Object.keys(orders).length === 0" class="empty-tr">
                                    <td colspan="9" class="empty-cell">
                                        {{ noParcels }}
                                    </td>
                                </tr>
                            </tbody>
                        </table>
                        <div v-if="isLoading" class="animation-container">
                            <lottie :options="defaultOptions" :height="150" :width="150"/>
                        </div>
                    </div>
                    <div v-else>
                        <div class="packages mobile">
                            <div v-if="isLoading" class="animation-container">
                                <lottie :options="defaultOptions" :height="120" :width="120"/>
                            </div>
                            <template v-if="Object.keys(orders).length > 0">
                                <div class="box" v-for="(order,index) in orders" @click="toOrder(order)">
                                    <div class="packages">
                                        <div class="package">
                                            <div class="direction">{{$t('message.out_package')}}</div>
                                            <div class="number">{{ order.ew_number }}</div>
                                            <div class="description">
                                                <div class="from">
                                                    {{order.sender_department_city}}
                                                    <div class="dep-number" v-if="order.sender_department_number">Відділення № {{ order.sender_department_number }}</div>
                                                </div>
                                                <div class="to">
                                                    {{order.receiver_department_city}}
                                                    <div class="dep-number" v-if="order.receiver_department_number">Відділення №{{ order.receiver_department_number }}</div>
                                                </div>
                                            </div>
                                            <div
                                                class="time_line"
                                            >
                                                <div
                                                    class="line"
                                                    :class="{
                                                        'lightblue':(order.status_id == 1),
                                                        'blue':([3,4,5,16].includes(parseInt(order.status_id))),
                                                        'green':([6,8].includes(parseInt(order.status_id))),
                                                        'red':([2,9,14,15].includes(parseInt(order.status_id))),
                                                        'half':([4,5,16].includes(parseInt(order.status_id))),
                                                        'full':([2,6,8,9,14,15].includes(parseInt(order.status_id))),
                                                        'circle':([2,8,9,14,15].includes(parseInt(order.status_id))),
                                                        'triangle':([1,3,4,5,6,16].includes(parseInt(order.status_id))),
                                                    }"></div>
                                            </div>
                                            <div class="status">
                                                <div class="departure">
                                                    <div class="status-title">{{$t('message.sended')}}</div>
                                                    <div class="date">{{ order.order_date | formatDate }}</div>
                                                </div>
                                                <div class="status_info">
                                                    <div class="status-title">{{$t('message.status')}}</div>
                                                    <div
                                                        class="info"
                                                        :class="{
                                                            'info--lightblue':(order.status_id == 1),
                                                            'info--blue':([3,4,5,16].includes(parseInt(order.status_id))),
                                                            'info--green':([6,8].includes(parseInt(order.status_id))),
                                                            'info--red':([2,9,14,15].includes(parseInt(order.status_id)))
                                                        }"
                                                    >
                                                        {{statuses[order.status_id] ? statuses[order.status_id].name_ua : ''}}
                                                    </div>
                                                    <!--                                                        {{statuses[order.status_id]}}</div>-->
                                                </div>
                                            </div>
                                            <div class="package_link">{{$t('message.more')}}</div>
                                        </div>
                                    </div>
                                </div>
                            </template>
                            <div class="mobile-no-parcels" v-if="!isLoading && Object.keys(orders).length === 0">
                                {{ noParcels }}
                            </div>
                        </div>
                    </div>
                </v-tab-item>
                <v-tab-item :key="2" :value="'tab-2'">
                    <div v-if="!isMobile()">
                        <table class="temp-package">
                            <thead>
                                <tr>
                                    <td>{{$t('message.en_num')}}</td>
                                    <td>{{$t('message.full_name_sender')}}</td>
                                    <td>{{$t('message.phone_sender')}}</td>
                                    <td>{{$t('message.department_number_and_address')}}</td>
                                    <td>{{$t('message.weight')}}</td>
                                    <td>{{$t('message.description')}}</td>
                                    <td>{{$t('message.created_at')}}</td>
                                    <td>{{$t('message.to_bill')}}</td>
                                    <td>{{$t('message.status')}}</td>
                                </tr>
                            </thead>

                            <tbody>
                                <template v-if="Object.keys(orders).length > 0">
                                    <tr v-for="(order, index) in orders" :key="index" @click="goToDetails($event, order.ew_number)">
                                        <td>{{ order.ew_number }}</td>
                                        <td v-if="order.delivery_type === 'B2C' && order.is_incoming === 1">
                                            {{ order.sender_company }}
                                        </td>
                                        <td v-else :title="order.sender_full_name">
                                            {{ order.sender_full_name }}
                                        </td>
                                        <td v-if="order.delivery_type === 'B2C' && order.is_incoming === 1">
                                            {{ $t('message.not_available') }}
                                        </td>
                                        <td v-else >
                                            <a :href="`tel:${order.sender_phone}`" class="phone">{{ order.sender_phone | formatPhone }}</a>
                                        </td>
                                        <td style="text-transform: capitalize">
                                            {{$t('message.department')}} №{{order.receiver_department_number}} ({{ order.receiver_department_address_ua }})
                                        </td>
                                        <td>{{ order.weight | formatWeight }}</td>
                                        <td>{{ order.description }}</td>
                                        <td>{{ order.order_date | formatDate}}</td>
                                        <td>{{ order.cost_pay_receiver | formatPrice }}</td>
                                        <td>
                                            <!--                                    <td :title="statuses[order.status_id]">-->
                                            <div class="actions">
                                                <div
                                                    :class="{
                                                        'status--lightblue':(order.status_id == 1),
                                                        'status--blue':([3,4,5,16].includes(parseInt(order.status_id))),
                                                        'status--green':([6,8].includes(parseInt(order.status_id))),
                                                        'status--red':([2,9,14,15].includes(parseInt(order.status_id))),
                                                    }"
                                                    class="status">
                                                    {{statuses[order.status_id] ? statuses[order.status_id].name_ua : ''}}
                                                    <!--                                                {{ statuses[order.status_id] }}-->
                                                </div>
                                                <!--                                            <router-link to="/orders/order" class="btn">-->
                                                <!--                                                {{$t('message.detail_info')}}-->
                                                <!--                                                <div class="icon"><plus-svg></plus-svg></div>-->
                                                <!--                                            </router-link>-->
                                            </div>
                                        </td>
                                    </tr>
                                </template>
                                <tr v-if="!isLoading && Object.keys(orders).length === 0" class="empty-tr">
                                    <td colspan="9" class="empty-cell">
                                        {{ noParcels }}
                                    </td>
                                </tr>
                            </tbody>
                        </table>
                        <div v-if="isLoading" class="animation-container">
                            <lottie :options="defaultOptions" :height="150" :width="150"/>
                        </div>
                    </div>
                    <div v-else>
                        <div class="packages mobile">
                            <div v-if="isLoading" class="animation-container">
                                <lottie :options="defaultOptions" :height="120" :width="120"/>
                            </div>
                            <template v-if="Object.keys(orders).length > 0">
                                <div class="box" v-for="(order, index) in orders" @click="toOrder(order)">
                                    <div class="packages">
                                        <div class="package">
                                            <div class="direction">{{$t('message.incoming')}}</div>
                                            <div class="number">{{ order.ew_number }}</div>
                                            <div class="description">
                                                <div class="from">
                                                    {{order.sender_department_city}}
                                                    <div class="dep-number" v-if="order.sender_department_number">Відділення № {{ order.sender_department_number }}</div>
                                                </div>
                                                <div class="to">
                                                    {{order.receiver_department_city}}
                                                    <div class="dep-number" v-if="order.receiver_department_number">Відділення № {{ order.receiver_department_number }}</div>
                                                </div>
                                            </div>
                                            <div
                                                class="time_line"
                                            >
                                                <div
                                                    class="line"
                                                    :class="{
                                                    'lightblue':(order.status_id == 1),
                                                    'blue':([3,4,5,16].includes(parseInt(order.status_id))),
                                                    'green':([6,8].includes(parseInt(order.status_id))),
                                                    'red':([2,9,14,15].includes(parseInt(order.status_id))),
                                                    'half':([4,5,16].includes(parseInt(order.status_id))),
                                                    'full':([2,6,8,9,14,15].includes(parseInt(order.status_id))),
                                                    'circle':([2,8,9,14,15].includes(parseInt(order.status_id))),
                                                    'triangle':([1,3,4,5,6,16].includes(parseInt(order.status_id))),
                                                }"></div>
                                            </div>
                                            <div class="status">
                                                <div class="departure">
                                                    <div class="status-title">{{$t('message.sended')}}</div>
                                                    <div class="date">{{ order.order_date | formatDate }}</div>
                                                </div>
                                                <div class="status_info">
                                                    <div class="status-title">{{$t('message.status')}}</div>
                                                    <div
                                                        class="info"
                                                        :class="{
                                                            'info--lightblue':(order.status_id == 1),
                                                            'info--blue':([3,4,5,16].includes(parseInt(order.status_id))),
                                                            'info--green':([6,8].includes(parseInt(order.status_id))),
                                                            'info--red':([2,9,14,15].includes(parseInt(order.status_id)))
                                                        }"

                                                    >{{statuses[order.status_id] ? statuses[order.status_id].name_ua : ''}}
                                                    </div>
                                                </div>
                                            </div>
                                            <!--                                            <div class="package_link">{{$t('message.more')}}</div>-->
                                        </div>
                                    </div>
                                </div>
                            </template>
                            <div class="mobile-no-parcels" v-if="!isLoading && Object.keys(orders).length === 0">
                                {{ noParcels }}
                            </div>
                        </div>
                    </div>
                </v-tab-item>
            </v-tabs>

            <router-link to="/package/create" class="button no_parcels" v-if="!isLoading && Object.keys(orders).length === 0">
                {{ $t('message.create_parcel') }}
            </router-link>

            <div class="pagination" v-if="pagination && pagination.pages > 1">
                <div
                    v-for="n in pagination.pages"
                    :class="{active: page == n}"
                    @click="setPage(n);setOrders();"
                >{{n}}
                </div>
                <!--                <div class="active">1</div>-->
                <!--                <div>2</div>-->
                <!--                <div>3</div>-->
            </div>

            <back-to-top bottom="30px" right="18px">
                <button type="button" class="btn btn-info btn-to-top">
                    <img src="/img/to-top.svg">
                </button>
            </back-to-top>
        </div>
    </div>
</template>

<script>
    import Search from "./svg/Search";
    import Plus from "./svg/Plus";
    import BackToTop from './BackToTop';
    import OrdersFilter from './orders/partials/Filter';
    import OrdersSearch from './orders/partials/Search';
    import OrdersSorting from './orders/partials/Sorting';
    import Lottie from 'vue-lottie';
    import * as animationData from './animation/preload.json';

    export default {
        name: "Orders",
        data() {
            return {
                tab: 'tab-1',
                orders: {},
                pagination: {},
                isLoading: true,
                defaultOptions: {animationData: animationData.default},
                animationSpeed: 1,
                filterPopups: {
                    filter: false,
                    search: false,
                    sorting: false
                },
                filters: {
                    is_incoming: 0,
                    is_archive: 0,
                    ew_number: ''
                },
                sorting: {
                    date: 'DESC'
                },
                filtersSelected: false,
                sortingSelected: false,
                searchFilled: false,
                page: 1,
                ordersQty: {}
            }
        },
        components: {
            "search-svg": Search,
            "plus-svg": Plus,
            BackToTop,
            OrdersFilter,
            OrdersSearch,
            OrdersSorting,
            'lottie': Lottie
        },
        filters: {
            formatWeight(v) {
                return `${v} кг`;
            },
            formatPrice(v) {
                return `${v} грн`;
            },
            formatPhone(v) {
                if( v.length === 12){
                    return [
                        '+' + v[0] + v[1] + v[2],
                        '(' + v[3] + v[4] + ')',
                        v[5] + v[6] + v[7],
                        v[8] + v[9],
                        v[10] + v[11]
                    ].join(' ');
                }
                return 'Не вказано';
            },
            formatDate(v) {
                return v.split(' ')[0].split('-').reverse().join('.');
            },
            shortFullName(v) {
                let fullName = v;
                let fragments = v.split(' ');
                return `${fragments[0]} ${fragments[1].substr(0, 1)}. ${fragments[2].substr(0, 1)}.`;
            }
        },
        methods: {
            toggleFilterPopup() {
                this.filterPopups.filter = !this.filterPopups.filter;
                this.closePopup('sorting');
                this.closePopup('search');
            },
            showSortingFilter() {
                this.filterPopups.sorting = !this.filterPopups.sorting;
                this.closePopup('filter');
                this.closePopup('search');
            },
            toggleSearchPopup() {
                this.filterPopups.search = !this.filterPopups.search;
                this.closePopup('sorting');
                this.closePopup('filter');
            },
            isMobile() {
                if (/Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent)) {
                    return true;
                }
                return false;
            },
            toOrder(order) {
                this.$router.push('/orders/' + order.ew_number)
            },
            setPage(n) {
                this.page = n;
            },
            changeOrdersTab(value) {
                this.setFilters('is_incoming', value);
                this.$store.commit('setIsIncoming', value);
                this.$refs.ordersFilter.resetFilters();
            },
            setFilters(param, value) {
                this.startLoading();
                this.filters[param] = value;
            },
            async setOrders() {
                this.startLoading();
                try{
                    const filters = {
                        filters: this.filters,
                        page: this.page,
                        sorting: this.sorting
                    }
                    const {data} = await axios.post('/order/list', filters);
                    this.orders = data.status ? data.result.ews : {};
                    this.pagination = data.status ? data.result.pagination : {};
                } catch (e) {}

                this.isLoading = false;
            },
            startLoading(){
                this.isLoading = true;
                this.orders = {};
                this.pagination = {};
            },
            onFilterApplied(filters) {
                this.filtersSelected = this.hasFilteredItems(filters);
                this.filters = Object.assign(this.filters, filters);
                this.closePopup('filter');
                this.setPage(1);
                this.setOrders();
            },
            onSearch(search) {
                this.filters.ew_number = search;
                this.searchFilled = search.length > 0;
                this.setOrders();
                this.closePopup('search');
            },
            onResort(sorting) {
                this.sorting.date = sorting;
                this.setOrders();
                this.closePopup('sorting');
                this.sortingSelected = this.hasSortingItems(sorting);
            },
            hasFilteredItems(filters) {
                return Object.values(filters).some(value => value !== '');
            },
            hasSortingItems(sorting) {
                return Object.values(sorting).some(value => value !== '');
            },
            closePopup(type) {
                this.filterPopups[type] = false;
            },
            toggleArchive(){
                const isArchive = this.filters.is_archive ? 0 : 1;
                this.setFilters('is_archive', isArchive);
                this.$store.commit('setIsArchive', isArchive);
                this.setOrders();
            },
            setDefaultFilters(){
                this.filters.is_incoming = this.$store.state.isIncoming;
                this.filters.is_archive = this.$store.state.isArchive;
                if( this.filters.is_incoming ){
                    this.tab = 'tab-2';
                }
            },
            async getActiveQuantity(){
                const {data} = await axios.post('/order/active-quantity');
                this.ordersQty = data;
            },
            goToDetails(e, ew_number){
                if( e.target.className !== 'phone' ){
                    this.$router.push({name: 'orderDetails', params: {ew_number}})
                }
            }
        },
        computed: {
            statuses: function () {
                const reducer = (a, c) => {
                    a[c.code] = c;
                    return a;
                };
                return Object.keys(this.$store.getters.statuses).length
                    ? this.$store.getters.statuses.reduce(reducer, {})
                    : {};
            },
            cities: function () {
                return this.$store.getters.cities;
            },
            departments: function () {
                return this.$store.getters.departments;
            },
            noParcels(){
                let msg = this.filters.is_archive ? this.$t('message.no_archive_parcels') : this.$t('message.no_active_parcels');

                if( this.filtersSelected ){
                    msg = this.$t('message.no_filter_parcels');
                } else if( this.searchFilled ){
                    msg = this.$t('message.no_search_parcels');
                }
                return msg;
            }
        },
        created() {
            this.$store.dispatch('setCities');
            this.$store.dispatch('setDepartments');
            this.$store.dispatch('setStatuses', {});

            this.setDefaultFilters();
            this.setOrders();

            this.getActiveQuantity();
        },
    }
</script>

<style>
    .temp-package td {
        padding: 4px 10px 6px;
    }
</style>
